package com.gs.utils;


import com.jfinal.aop.Inject;
import com.jfinal.plugin.activerecord.Config;
import com.jfinal.plugin.activerecord.Db;
import com.jfinal.plugin.activerecord.DbKit;
import com.jfinal.plugin.activerecord.Record;
import com.jfinal.plugin.activerecord.dialect.MysqlDialect;
import com.jfinal.plugin.druid.DruidPlugin;

import javax.sql.DataSource;
import java.net.InetAddress;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;

//多数据源操作类
public class DBService  {
    //根据id获取数据源
    @Inject
    Scf_SiteBasicService scf_siteBasicService;

    public  String getDbUrl(String Scf_SiteDatabaseID){


        ScfSitebasic d= scf_siteBasicService.getSegmentById(Scf_SiteDatabaseID);
        if (d!=null){
            d.getSqlCnnString();

        }
        return "";
    }
    //获取数据源
    public static Record SqlCnntoMysqlCon(String con){
        if (!con.equals("")){
            Record db=new Record();
            String [] arr=   con.split(";");
            for (String item:arr) {
                if (item.toLowerCase().indexOf("Data Source=".toLowerCase())>-1){
                    String []b= item.split("=");
                    db.set("ip",b[1]);
                }
                if (item.toLowerCase().indexOf("Initial Catalog".toLowerCase())>-1){
                    String []b= item.split("=");
                    db.set("db",b[1]);
                }
                if (item.toLowerCase().indexOf("User ID".toLowerCase())>-1){
                    String []b= item.split("=");
                    db.set("user",b[1]);
                }
                if (item.toLowerCase().indexOf("Password".toLowerCase())>-1){
                    String []b= item.split("=");
                    db.set("pw",b[1]);
                }
            }

            db.set("jdbc","jdbc:mysql://"+db.get("ip")+"/"+db.get("db")+"?useUnicode=true&characterEncoding=UTF-8&serverTimezone=Asia/Shanghai");
            return db;
        }
        return null;
    }
    public static void initDB(){

        List<ScfSitebasic> db= Scf_SiteBasicService.getSegmentBySorce();
        if (db!=null){
            for (ScfSitebasic d:db) {
                try
                {
                    Record s=  SqlCnntoMysqlCon(d.getSqlCnnString());
                    initMTXOracleDruidPlugin(s.getStr("jdbc"), s.getStr("user"),s.getStr("pw").trim(),s.getStr("db"));
                    System.out.println(s.getStr("jdbc"));


                }
                catch (Exception ex){
                    System.out.println(ex.getMessage());
                }
            }



        }


    }

    /**
     * 动态添加数据源
     * @param sqlCnnString
     */
    public static void intSynDB(String sqlCnnString) {
        try {
            Record s = SqlCnntoMysqlCon(sqlCnnString);
            initMTXOracleDruidPlugin(s.getStr("jdbc"), s.getStr("user"), s.getStr("pw").trim(), s.getStr("db"));
            System.out.println(s.getStr("jdbc"));


        } catch (Exception ex) {
            System.out.println(ex.getMessage());
        }

    }

    /**
     * 初始化数据源
     * @param jdbc
     * @param user
     * @param pw
     * @param db
     */
    public static void initMTXOracleDruidPlugin(String jdbc, String user, String pw, String db){
        try{
            System.out.println(jdbc);
            DruidPlugin druidPlugin = new DruidPlugin(jdbc.replace(",",":"), user,pw);
            //druidPlugin.setDriverClass("com.microsoft.sqlserver.jdbc.SQLServerDriver");
            druidPlugin.setDriverClass("com.mysql.cj.jdbc.Driver");


            if (druidPlugin.start()){
                if(DbKit.getConfig(db)==null){
                    DataSource d=  druidPlugin.getDataSource();
                    com.jfinal.plugin.activerecord.Config config=new Config(db,d,new MysqlDialect());
                    DbKit.addConfig(config);
                }

                System.out.println("创建成功！");
            }

        }catch (Exception ex){
            System.out.println(ex.getMessage());
        }}




}
